"use strict";

/**
 * generate strong password
 * @param {number} [length=10] length of password to generate
 * @return {string}
 */
function generate(length = 10)
{
  const groups = [
    '0123456789',
    'abcdefghijklmnopqrstuvwxyz',
    'ABCDEFGJIJKLMNOPQRSTUVWXYZ',
    '!@$%^*_'
  ];

  let availableOrder = [0, 1, 2, 3];
  let order = [];

  while (availableOrder.length > 0)
  {
    order.push(availableOrder.splice(Math.floor(Math.random() * availableOrder.length), 1)[0]);
  }

  let password = '';

  for (let i = 0; i < length; i++)
  {
    let currentGroup = groups[i % groups.length];

    password += currentGroup[Math.floor(Math.random() * currentGroup.length)];
  }

  return password;
}

module.exports = generate;
